
var Messages = {
	DetectPosition : "Requesting your location...<br>Make sure your location services is enabled in Settings->Location.",
	Connecting : "Loading tow trucks...",
	ConnectingFail : "Fail to connect to the Internet.<br> Check network setting and restart the app.",
	Close : "Close",
	TurnOnGPS : "Connecting to the Internet. Please enable location detection in Settings->Location to find the nearest tow truck.",
	ErrorCode : "Error code:",
	ErrorDesc : "Description",
	NoEvak : "Sorry, no tow trucks found",
	Nearest : "The nearest services out of ",
	Search : "Looking for the nearest tow trucks. This can take up to 15 seconds",
	LoadMap : "Loading tow truck list, this can take up to 15 seconds.",
	Reviews : "Reviews",
	EvakLoadFail : "Loading of tow trucks failed, check the Internet connection.",
	PleaseWait : "Please Wait",
	Loading : "Its loading....",
	txtMiles : 'mi',
	txtKmToMiles : 0.621371
};

function setEnglish(){
	$("#TextName").html("Roadside Assistance 24");
	$("#TextLoading").html("Loading...");
	$("#MenuList").html("List");
	$("#MenuMap").html("Map");
	$("#MenuAbout").html("About");
}

function setRussian(){
	Messages.DetectPosition = "Для поиска ближайшего эвакуатора запрашиваем Ваше местоположение...<br>Убедитесь, что определение местоположения разрешено в Настройки->Местоположение.";
	Messages.Connecting = "Загружаем карту...";
	Messages.Close = "Закрыть";
	Messages.ConnectingFail = "Не удалось подключиться к Интернет.<br> Проверьте настройки сети и перезагрузите приложение.";
	Messages.TurnOnGPS = "Для поиска ближайшего к Вам эвакуатора включите определение Вашего местоположения в Настройки->Местоположение.";
	Messages.ErrorCode = "Код ошибки:";
	Messages.ErrorDesc = "Описание";
	Messages.NoEvak = "Извините, не найдено ни одного эвакуатора";
	Messages.Nearest = "Эвакуаторы ближайшие к Вам из ";
	Messages.Search = "Ищем ближайший эвакутор, это может занять до 30 сек";
	Messages.LoadMap = "Загружем карту с указанием местоположения эвакуаторов, это может занять до 30 сек.";
	Messages.Reviews = "Отзывов";
	Messages.EvakLoadFail = "Загрузка эвакуаторов не удалась, проверьте подключение к Интернет";
	Messages.PleaseWait = "Пожалуйста, подождите";
	Messages.Loading = "Загружаем...";
	Messages.txtMiles = 'км';
	Messages.txtKmToMiles = 1;

	$("#TextName").html("Эвакуатор");
	$("#TextName1").html("Эвакуатор");
	$("#TextName2").html("Эвакуатор");
	$("#TextName3").html("Эвакуатор 2.3.2");
	$("#TextLoading").html("Загрузка...");
	$("#TextAbout").html('');
	$("#TextAbout1").html('По вопросам сотрудничества пишите: <a href="mailto:add@evakuator-mos.ru">add@evakuator-mos.ru</a>');
	$("#TextGaranty").html("Все размещенные материалы носят информационный характер и не являются публичной офертой. Служба не несет ответственнсти за действия или бездействие участников проекта, которые являются самостоятельными юридическими или физическими лицами.");
	$("#TextCopy").html("&copy; Ананьев П.П., 2012-2018");
	$("#TextURL").html('www.evakuator-mos.ru');
	$("#MenuList").html("Ближайшие");
	$("#MenuMap").html("Карта");
	$("#MenuAbout").html("О программе");
	$("#TextRate").html("Оценить приложение");
	
	AppRate.preferences.useLanguage = 'ru';
	AppRate.preferences.displayAppName = 'Эвакуатор';
	AppRate.preferences.customLocale = {
		title: "Пожалуйста, оцените приложение %@",
		message: "Это не займет больше минуты, но очень поможет приложению. Спасибо Вам за поддержку!",
		cancelButtonLabel: "Нет, спасибо",
		laterButtonLabel: "Напомнить позже",
		rateButtonLabel: "Оценить сейчас",
		yesButtonLabel: "Да!",
		noButtonLabel: "Не очень",
		appRatePromptTitle: 'Вам нравится приложение %@?',
		feedbackPromptTitle: 'Не будете ли Вы возражать против того, чтобы уделить минуту и оценить его?'
	  };
}

function languageChanged(lang) {	
    switch (lang){
    	case "russian":
    		setRussian();
    		break;
    }
}

// Determine theme depending on device
var isAndroid = Framework7.prototype.device.android === true;
var isIos = Framework7.prototype.device.ios === true;
 
// Set Template7 global devices flags
Template7.global = {
    android: isAndroid,
    ios: isIos
};
 
// Define Dom7
var $$ = Dom7;
 
if (isAndroid) {
    // Change class
    $$('.view.navbar-through').removeClass('navbar-through').addClass('navbar-fixed');
    // And move Navbar into Page
    //$$('.view .navbar').prependTo('.view .page');
}
 
// Init App
var myApp = new Framework7({
    // Enable Material theme for Android device only
    material: isAndroid ? true : false,
    // Enable Template7 pages
    template7Pages: true,
	ajaxLinks: '.ajax', // Ajax will work on links with "ajax" class
	externalLinks: '.external'
});

// Init View
var mainView = myApp.addView('.view', {
    // Material doesn't support it but don't worry about it
    // F7 will ignore it for Material theme
    dynamicNavbar: true
});


function restartApplication() {
  myApp.pullToRefreshTrigger(ptrContent);
}


// Pull to refresh content
var ptrContent = $$('.pull-to-refresh-content');
 
// Add 'refresh' listener on it
ptrContent.on('refresh', function (e) {
		document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.DetectPosition+ '</div>';
		myMap = 0;
		routeOld=0;

		CurPos = 0;
		evaks= [];
		bUpdated = 0;
		iDistCalc = 0;
		iDistCalced = 0;
		placemark = 0;

		trafficControl = 0;

		evakNumber = 0;

		bExact = 0;
		onAppReady();
	});
	
var inAppBrowserRef;

function hijack_externalLinks(){

    $$(document).on('click', "a[href^='https://']", function (e) {

		navigator.notification.activityStart(Messages.PleaseWait, Messages.Loading);
		
		inAppBrowserRef = cordova.InAppBrowser.open( this.href , '_blank', 'location=no,hidden=yes,closebuttoncaption=Ok' );
		inAppBrowserRef.addEventListener('loadstop', loadStopCallBack);
		inAppBrowserRef.addEventListener('loaderror', inAppBrowserbLoadError);
				
         this.href = '';
		 e.preventDefault();
		 e.stopPropagation();
          });
}

function inAppBrowserbLoadError(event) {
	navigator.notification.activityStop();
}

function loadStopCallBack() {

    if (inAppBrowserRef != undefined) {
	
        inAppBrowserRef.insertCSS({file: "https://evakuator-mos.ru/appstyle.css"}, function () {
			navigator.notification.activityStop();
			inAppBrowserRef.show();
		});
    }

}

// Handle Cordova Device Ready Event
$$(document).on('deviceready', function() {

	AppRate.preferences.storeAppURL = {
		ios: '529715171',
		android: 'market://details?id=ru.softformobile.Evakuator'
	};	
	
	myApp.sizeNavbars('.view');
	hijack_externalLinks();
	
	if (navigator.globalization !== null) {
	
		navigator.globalization.getLocaleName(
			function (locale) {
				if ((locale.value.indexOf("ru")!=-1)||(locale.value.indexOf("be")!=-1)||(locale.value.indexOf("uk")!=-1)||(locale.value.indexOf("kk")!=-1)||(locale.value.indexOf("tg")!=-1)||(locale.value.indexOf("ka")!=-1)||(locale.value.indexOf("hy")!=-1)||(locale.value.indexOf("ab")!=-1)||(locale.value.indexOf("uz")!=-1)||(locale.value.indexOf("ky")!=-1)||(locale.value.indexOf("tk")!=-1)){
					languageChanged("russian");
					myApp.pullToRefreshTrigger(ptrContent);
				}
				else {
					setEnglish();
					myApp.pullToRefreshTrigger(ptrContent);
				}
			},
			function() {
				setEnglish();
				myApp.pullToRefreshTrigger(ptrContent);
				}
		);
	}
	else{
		setEnglish();
		myApp.pullToRefreshTrigger(ptrContent);
	}
	
});

//Success callback
var suc = function(p) {
            currentLatitude = p.coords.latitude;
            currentLongitude = p.coords.longitude;
			document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.Connecting +'</div>';
            
			if(!window.google) {
				myApp.pullToRefreshDone();
				document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.ConnectingFail +'<br><button name="buttonClick" onclick="navigator.app.exitApp();">' + Messages.Close +'</button></div>';
			}

			try{
				initialize();
			}
			catch(e)
			{
				myApp.pullToRefreshDone();
				document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.ConnectingFail +'<br><button name="buttonClick" onclick="navigator.app.exitApp();">' + Messages.Close +'</button></div>';
			}
    }
	
var fail = function(error) {
	if (error.code == error.TIMEOUT){
		// Attempt to get GPS loc timed out after 5 seconds, 
		// try high accuracy location
		navigator.geolocation.getCurrentPosition(
			   suc, fail1,
			   {maximumAge:600000, timeout:300000, enableHighAccuracy: true});
	}
	else{
		document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.TurnOnGPS +'\n<div class="content-block">' + Messages.ErrorCode +' '+ error.code + '\n' + Messages.ErrorDesc + ': ' + error.message + '\n</div></div>';
		myApp.pullToRefreshDone();
	}
}
	
var fail1 = function(error) {
	document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' +Messages.TurnOnGPS+ '\n<div class="content-block">' + Messages.ErrorCode +' '+ error.code + '\n' + + Messages.ErrorDesc + ': ' + error.message + '\n</div></div>';
	myApp.pullToRefreshDone();
}

var options = {
    timeout: 5000,
    maximumAge: 600000,
    enableHighAccuracy: false
};

function onAppReady() {
	
	jQuery.ajax({
					type: 'POST',
					url: 'https://www.evakuator-mos.ru/map/getcoord.php',
					data: '',
					dataType:'json',
					success: function(data) {
						jQuery.each( data, function(id, info){

						if(!info[7]){
							info[7] = 0;
							info[6] = 0;
						}
						
						evaks.push({distance: 100000000, name: info[0], coord:[parseFloat(info[4]), parseFloat(info[3])],tel: info[1], img : info[5], rating: info[7], numOtz : info[6], desc :info[2], url : info[9], online : info[8] });
						evakNumber++;
						});

						bUpdated = 1;
                },
                error: function(request, status, error) {
                    errorLog('error2-getcoord.php:'+xhr.responseText+status+serror);
                },
            });
	
    AppRate.promptForRating(false);
	try {
        if (navigator.geolocation !== null) {
            navigator.geolocation.getCurrentPosition(suc, fail, options);
        }
        else {
            document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' +Messages.TurnOnGPS+ '</div>';
			myApp.pullToRefreshDone();
        }
    } catch (e) {
         document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' +Messages.TurnOnGPS+ '</div>';
		myApp.pullToRefreshDone();
    }
}

function errorLog(text)
	{
		jQuery.ajax({
			type: 'POST',
			url: 'https://www.evakuator-mos.ru/error.php',
			data: {param1: text}
		});
	}

var currentLatitude = 55.75399399999374;
var currentLongitude = 37.62209300000001;

var myMap;
	var routeOld=0;

	var CurPos = 0;
	var evaks= [];
	var bUpdated = 0;
	var iDistCalc = 0;
	var iDistCalced = 0;
	var placemark = 0;

	var MAXNearestDist = 15;
	var MAXDist = 200000;

	var trafficControl = 0;

	var geolocationControl;

	var evakNumber = 0;

	var bExact = 0;
	
	function getReitingStars(rating) {
	var ratingHtml = '';
	for (var i = 0; i < 5; i++) {
		if (rating < (i + 0.5)) {
		  ratingHtml += '&#10025;';
		} else {
		  ratingHtml += '&#10029;';
		}
	}
	return ratingHtml;
}
	
	function compareNumeric(a, b) {
	  return a.distance - b.distance;
	}
	
	function formatTowListRow(evaksNearest){
		var html = '<li><div class="item-link item-content"><div class="item-media"><a href="' + evaksNearest.url +'"><div class="item-media-table"><img src="https://www.evakuator-mos.ru/map'+evaksNearest.img +'" width="80"><div>' +getReitingStars(evaksNearest.rating) +'</div><div class="otzyv_num">' + Messages.Reviews + ': '+evaksNearest.numOtz + '</div></div></a></div><div class="item-inner"><div class="item-title-row-bg"><div class="item-title">'+evaksNearest.name+'</div><div class="item-after">';
		
		if (evaksNearest.online){
			html = html + '<div class = "tow-online"><i class="f7-icons">navigation_fill</i></div> ';
		}
		else{
			html = html + '~';
		}

		html = html + evaksNearest.distanceText + '</div></div><div class="item-subtitle">'+formatTelLink(evaksNearest.tel)+'</div><div class="item-text">' + evaksNearest.desc.split('<')[0] + '</div></div></div></li>';
		return html;
	}
	
	function WaitForDistCalc(){
			//вывод на сайт ближайших эвакуаторов
			
			var html = '<div class="content-block-title">' + Messages.Nearest+evaks.length+':</div><div class="list-block media-list"><ul>' + formatTowListRow(evaks[0]);

			for (var i = 1; i < MAXNearestDist; i++){
				if(i>=evaks.length) break;
				if (evaks[i].distance < MAXDist ){
					
					html = html + formatTowListRow(evaks[i]);
				}
				else break;
			}
			document.getElementById('divPhoneNearest').innerHTML = html + '</ul></div>';
			myApp.pullToRefreshDone();

	}

	
var rad = function(x) {
  return x * Math.PI / 180;
};

var getDistance = function(lat1, lng1, lat2, lng2) {
  var R = 6378137; // Earth’s mean radius in meter
  var dLat = rad(lat2 - lat1);
  var dLong = rad(lng2 - lng1);
  var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
    Math.cos(rad(lat1)) * Math.cos(rad(lat2)) *
    Math.sin(dLong / 2) * Math.sin(dLong / 2);
  var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
  var d = R * c;
  return d; // returns the distance in meter
};
	
function ShowNearestEvak(){
	//подождать координаты
	if (!bUpdated){
		setTimeout(ShowNearestEvak, 30);
	}
	else{
		//добавить растояние до пользователя в массив эвакуаторов
		
		//var end = new google.maps.LatLng(CurPos[0],CurPos[1]);
		for (var i = 0; i < evaks.length; i++) {
			//var start = new google.maps.LatLng(evaks[i].coord[0], evaks[i].coord[1]);
			evaks[i].distance = getDistance(evaks[i].coord[0], evaks[i].coord[1], CurPos[0],CurPos[1]);
			evaks[i].distanceText =  Math.round(evaks[i].distance /1000*Messages.txtKmToMiles) + ' '+Messages.txtMiles;
		}
		//отсортировать по расстоянию
		evaks.sort(compareNumeric);
		
		
		iDistCalced = iDistCalc;
		WaitForDistCalc();
	}
}

	function geo_success (latitude, longitude) {
		iDistCalc = 0;
		iDistCalced = 0;
		
		// Меняем иконку кнопки на прелоадер.
				document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.Search + '...</div>';
		
		CurPos = [latitude, longitude];
				var location = [latitude, longitude],
					map = myMap;
			   
				//показать ближайшие эвакуаторы
				setTimeout(ShowNearestEvak, 30);
	}

	  
function loadTowGoogle(results, status) {
	if (status === google.maps.places.PlacesServiceStatus.OK) {
	  for (var i = 0; i < results.length; i++) {
		createTowMarker(results[i]);
	  }
	}
}
  
function buildIWContent(place) {
        document.getElementById('iw-url').innerHTML = '<b>' + place.name + '</b>';
        document.getElementById('iw-address').textContent = place.vicinity;

        if (place.formatted_phone_number) {
          document.getElementById('iw-phone-row').style.display = '';
          document.getElementById('iw-phone').innerHTML = formatTelLink(place.formatted_phone_number);
        } else {
          document.getElementById('iw-phone-row').style.display = 'none';
        }

        // Assign a five-star rating to the hotel, using a black star ('&#10029;')
        // to indicate the rating the hotel has earned, and a white star ('&#10025;')
        // for the rating points not achieved.
        if (place.rating) {
          document.getElementById('iw-rating-row').style.display = '';
          document.getElementById('iw-rating').innerHTML = getReitingStars(place.rating);
          }
        else {
          document.getElementById('iw-rating-row').style.display = 'none';
        }
      }

  
function createTowMarker(place) {
        var placeLoc = place.geometry.location;
		
		var icon = 'https://www.evakuator-mos.ru/map/car-red-small.png';
		
        var marker = new google.maps.Marker({
          map: myMap,
          position: place.geometry.location,
			icon: icon
        });

        google.maps.event.addListener(marker, 'click', function() {
			service.getDetails(place, function(place, status) {
			  if (status === google.maps.places.PlacesServiceStatus.OK) {
				  infowindow.open(myMap, marker);
				   buildIWContent(place);
			  }
			});

        });
      }

function LoadGoogleRoadside()
{
	var center = myMap.getCenter();
	
	service.nearbySearch({
		  location: center,
		  radius: 50000,
		  name: 'towing service'
		}, loadTowGoogle);
}

function loadMaps(){
		
		var center = {lat: currentLatitude, lng: currentLongitude};
		myMap = new google.maps.Map(document.getElementById('tab-2'), {
			zoom: 10,
			mapTypeId: google.maps.MapTypeId.ROADMAP,
			center: center
		});
		
		var trafficLayer = new google.maps.TrafficLayer();
		trafficLayer.setMap(myMap);
		
		infowindow = new google.maps.InfoWindow({
          content: document.getElementById('info-content')
        });

		$$('#tab2').on('show', function () {
			var center = myMap.getCenter();
			google.maps.event.trigger(myMap, 'resize');
			myMap.setCenter(center);
		});
				
        service = new google.maps.places.PlacesService(myMap);
        LoadGoogleRoadside();
		loadNearestToMap();
}

var txtCodeCall = "yaCounter1820941.reachGoal(\'zvonok\',{pril:0, tel:\'";
function formatTelLink(tel){
	return "<a onClick=\"" + txtCodeCall +tel+'\'}); return true;" href="tel:'+tel+'\">'+tel+'</a>';
}

function loadNearestToMap(){
		  /*Вывод ближайших эвакуаторов на карту*/
		  for (var i = 0; i < 15; i++){
				if (evaks[i].distance > MAXDist ) return;
				var description = '<div class="map-image"><img  src="https://www.evakuator-mos.ru/map'+evaks[i].img +'"/><div>' + getReitingStars(evaks[i].rating) + '<div class="otzyv_num">'+ Messages.Reviews +': '+evaks[i].numOtz + '</div></div></div><div class="map-desc">'+evaks[i].desc + '</div>';
						
				var text = evaks[i].name + '<br><br>' +formatTelLink(evaks[i].tel)+'<br>';

				
				var content = "<b>" + text + "</b><br>" + description;
				var title = evaks[i].tel + ' ' + evaks[i].name;
				var icon;
				if(evaks[i].online){
					icon = 'https://www.evakuator-mos.ru/map/car.png';
				}
				else{
					icon = 'https://www.evakuator-mos.ru/map/car-red.png';
				}
	
				var pos = {lat: parseFloat(evaks[i].coord[0]), lng: parseFloat(evaks[i].coord[1])};
				  
				var marker = new google.maps.Marker({
					position: pos,
					map: myMap,
					title: title,
					icon: icon
				  });
				
				attachMessage(marker, content);
		  }
}
function attachMessage(marker, content) {
  var infowindow = new google.maps.InfoWindow({
    content: content
  });

  marker.addListener('click', function() {
    infowindow.open(myMap, marker);
  });
}
var bMapLoaded = false;
	function initialize () {

		document.getElementById('divPhoneNearest').innerHTML = '<div class="center">' + Messages.LoadMap + '</div>';
		
		$$('#tab2').on('show', function () {
			if(!bMapLoaded){
				bMapLoaded = true;
				jQuery.getScript("https://maps.googleapis.com/maps/api/js?key=AIzaSyAd07IL8fdelPIdHb--4Nzdt2eQLQlLjOI&libraries=places&callback=loadMaps");
			}
		});
		
		
		bExact = 0;
		
		geo_success(currentLatitude, currentLongitude);
		

	}